          #include <P16F628A.INC>
            LIST        p=16F628A     
            __CONFIG    H'3F10'             ; 
                                     
            
Sec           equ         20h               ;    
Sec1          equ         21h               ; 
shet          equ         22h               ;      
scetbit       equ         23h               ;      spi
ctr           equ         24h               ;    
bcd1          equ         25h               ;  -  
bcd2          equ         26h               ; 
bcd3          equ         27h               ;
edin          equ         28h               ;   
desiat        equ         29h               ; 
sotni         equ         2Ah               ;
dat_ind       equ         2Bh               ;      spi
adr_ind       equ         2Ch               ;      spi
varLL         equ         2Dh               ;    
varHH         equ         2Eh               ;  ()   
rezLL         equ         2Fh               ;    
rezHH         equ         30h               ;            

flag          equ         7Dh               ;  
W_TEMP        equ         7Eh               ;     W
STATUS_TEMP   equ         7Fh               ;    STATUS

#DEFINE       trig        PORTB,3           ; trig  
#DEFINE       echo        PORTB,0           ; echo  

#DEFINE       datai       PORTB,5           ;    MAX7219
#DEFINE       cs          PORTB,6           ;   MAX7219
#DEFINE       clk         PORTB,7           ;   MAX7219


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h             ;     0004h
       
              movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;
                
              btfsc       PIR1,TMR1IF       ;    .  TMR1
              goto        prov_tmr1         ; :    prov_tmr1
              
              btfss       echo              ;   .  TMR1 : 
                                            ;   \ echo
              goto        stop_tmr1         ; echo  0:    stop_tmr1

              bsf         STATUS,RP0
              bcf         OPTION_REG,INTEDG  ;    INT
              bcf         STATUS,RP0

              bsf         T1CON,TMR1ON      ; echo  1:   TMR1
              bcf         INTCON,INTF       ;   INT
              goto        exxit             ;   exxit

stop_tmr1     bcf         T1CON,TMR1ON      ;  TMR1
s_t1          movf        TMR1H,W           ;    TMR1  
              movwf       varHH             ;    () 
              movf        TMR1L,W           ;  
              movwf       varLL             ;
              bcf         INTCON,INTE       ;   INT
              bsf         flag,0            ;     () 
              movlw       .4                ;  4    
              movwf       shet              ;
              clrf        TMR1L             ;   TMR1
              clrf        TMR1H             ;
              bcf         PIR1,TMR1IF       ;    . TMR1
              bsf         T1CON,TMR1ON      ;  TMR1
              goto        exxit             ;   exxit
             
prov_tmr1     btfss       INTCON,INTE       ;    INT
                                            ;
              goto        p_t1              ; :    p_t1
              bcf         T1CON,TMR1ON      ; :   TMR1
              movlw       .156              ;  39936    TMR1
              movwf       TMR1H             ;
              clrf        TMR1L             ;
              goto        s_t1              ;   s_t1
p_t1          decfsz      shet,F            ;  shet ( )
              goto        exx1              ; shet   0:    exx1
              bcf         T1CON,TMR1ON      ;  TMR1
              clrf        TMR1L             ;   TMR1
              clrf        TMR1H 
              bsf         flag,1            ;   

exx1          bcf         PIR1,TMR1IF       ;     TMR1
exxit         swapf       STATUS_TEMP,W     ;   
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
                                            ;
              retfie                        ;    

             

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                 
             
Start         movlw       b'01000000'       ;  PORTB
              movwf       PORTB
              
              movlw       b'00000111'       ; 
              movwf       CMCON

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00010111'       ;  \  B  
              movwf       TRISB             ;RB0-RB2, RB4  ,   
              bcf         STATUS,RP0        ; 0-    

              clrf        flag              ;  
             
              movlw       b'00000000'       ;  TMR1:  TMR1 1:1,   
              movwf       T1CON             ;   
              clrf        TMR1L             ;   TMR1
              clrf        TMR1H
              bsf         INTCON,PEIE       ;   
              bcf         PIR1,TMR1IF       ;     TMR1
              bsf         STATUS,RP0        ; 1- 
              bsf         PIE1,TMR1IE       ;    TMR1
              bcf         STATUS,RP0        ; 0- 
              
              call        init_lcd          ;   (MAX7219) 
              call        signal_not        ;     "- - -"  
                                            ;  
              call        start_pul         ;    start_pul
              bsf         INTCON,GIE        ;  
             
opros         btfsc       flag,0            ;     ()
              call        vivod             ;    
                                            ; ()   
              btfsc       flag,1            ;   
              call        start_pul         ;    start_pul
              goto        opros             ;   opros  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vivod         bcf         flag,0            ;     ()
              call        del               ;     
           
              movf        rezHH,W           ;    
              sublw       .1                ;    400  
              btfss       STATUS,C          ; (bin2bcd)    
              goto        viv_1             ; 
              btfss       STATUS,Z          ;
              goto        viv_2             ;
              movf        rezLL,W           ;
              sublw       .144              ;
              btfss       STATUS,C          ;
              goto        viv_1             ;
viv_2         call        bin2bcd           ;    
                                            ; 
              call        send_rast         ;       
                                            ; ()   
              return                        ;  
viv_1         call        signal_not        ;     "- - -" 
                                            ; 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

start_pul     bcf         flag,1            ;   
              bsf         trig              ;  1  / trig
              movlw       .3                ; 10 
              movwf       Sec               ;
pul_1         decfsz      Sec,F             ;
              goto        pul_1             ;
              bcf         trig              ;  / trig
             
              bsf         STATUS,RP0
              bsf         OPTION_REG,INTEDG  ;    INT
              bcf         STATUS,RP0              

              bcf         INTCON,INTF       ;    INT
              bsf         INTCON,INTE       ;   INT
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

del          clrf         rezLL             ;      58
             clrf         rezHH             ;(varLH, varLL):58
d1           movlw        .58               ;   
             subwf        varLL,F           ;  varHH, varLL
             btfsc        STATUS,C          ;    rezLH, rezLL 
             goto         d2                ;    
             movlw        .1                ;
             subwf        varHH,F           ;
             btfss        STATUS,C          ;
             return                         ;                                            
d2           incfsz       rezLL,F           ;   
             goto         d1                ;
             incf         rezHH,F           ;                                             
             goto         d1                ;
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                            

bin2bcd       movlw       .16               ;   
              movwf       ctr               ; 
              clrf        bcd1              ;   
              clrf        bcd2              ;  rezHH, rezLL
              clrf        bcd3              ; : 
              goto        start_1           ;    bcd3
                                            ;    bcd3
adjdec        movlw       0x33              ;    bcd2
              addwf       bcd1,F            ;    bcd2
              addwf       bcd2,F            ;     bcd1
              addwf       bcd3,F            ;
                                            ;
              movlw       0x03              ;
              btfss       bcd1,3            ;
              subwf       bcd1,F            ;
              btfss       bcd2,3            ;
              subwf       bcd2,F            ;
              btfss       bcd3,3            ;
              subwf       bcd3,F            ;
                                            ;
              movlw       0x30              ;
              btfss       bcd1,7            ;
              subwf       bcd1,F            ;
              btfss       bcd2,7            ;
              subwf       bcd2,F            ;
              btfss       bcd3,7            ;
              subwf       bcd3,F            ;
                                            ;
start_1       rlf         rezLL,F           ;
              rlf         rezHH,F           ;
              rlf         bcd3,F            ;
              rlf         bcd2,F            ;
              rlf         bcd1,F            ;
              decfsz      ctr,F             ;
              goto        adjdec            ;
                                            ;
              movf        bcd3,W            ;     
              andlw       b'00001111'       ; bcd3   edin
              movwf       edin              ;
              
              swapf       bcd3,W            ;    
              andlw       b'00001111'       ; bcd3   desiat
              movwf       desiat            ;

              movf        bcd2,W            ;    
              andlw       b'00001111'       ; bcd2   sotni
              movwf       sotni             ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     ()   
                               
send_rast     movlw       0x01              ;   edin  1- 
              movwf       adr_ind           ;
              movf        edin,W            ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x02              ;   desiat  2- 
              movwf       adr_ind           ;
              movf        desiat,W          ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x03              ;   sotni  3- 
              movwf       adr_ind           ;
              movf        sotni,W           ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    "- - - "   
        
signal_not    movlw       0x04              ; 4- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x03              ;   3-  
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x02              ;   2- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x01              ;   1- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  (MAX7219)  

init_lcd      call        pauslcd           ;   2 
              movlw       0x0F              ;  
              movwf       adr_ind           ;
              movlw       0x00              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0C              ; 
              movwf       adr_ind           ;
              movlw       0x01              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0A              ; 31/32
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x09              ; BCD Code B   
              movwf       adr_ind           ;
              movlw       0xFF              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0B              ;  4 
              movwf       adr_ind           ;
              movlw       0x03              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  2-    (MAX7219)     SPI

send         bcf         cs                 ;    CS
             movlw      .8                  ;    adr_ind
             movwf      scetbit             ;
povtor       bcf        clk                 ;
             btfsc      adr_ind,7           ;
             bsf        datai               ;
             btfss      adr_ind,7           ;
             bcf        datai               ;
             bsf        clk                 ;
             rlf        adr_ind,F           ;
             decfsz     scetbit,F           ;
             goto       povtor              ;
             
             movlw      .8                  ;    dat_ind
             movwf      scetbit             ;
povtr1       bcf        clk                 ;
             btfsc      dat_ind,7           ;
             bsf        datai               ;
             btfss      dat_ind,7           ;
             bcf        datai               ;
             bsf        clk                 ;
             rlf        dat_ind,F           ;
             decfsz     scetbit,F           ;
             goto       povtr1              ;
             bcf        clk                 ;
             bsf        cs                  ;  1    CS                 
             return                         ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pauslcd       movlw       .4                ;  2 
              movwf       Sec1              ;
p3            movlw       .166              ;
              movwf       Sec               ;
p2            decfsz      Sec,F             ;
              goto        p2                ;
              decfsz      Sec1,F            ;
              goto        p3                ;
              return                        ;  
                           
              end                           ;  
                                            ;
